Last Comment Bug 500303 - Infinite loop of update failures
: Infinite loop of update failures
Status: RESOLVED WORKSFORME
[testday-20120713]
:
Product: Toolkit
Classification: Components
Component: Application Update (show other bugs)
: 1.9.0 Branch
: x86 Windows XP
: -- critical with 2 votes (vote)
: ---
Assigned To: Nobody; OK to take it and work on it
:
Mentors:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2009-06-24 15:00 PDT by Jean-Marie COUPRIE
Modified: 2012-08-18 03:55 PDT (History)
11 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments

Description Jean-Marie COUPRIE 2009-06-24 15:00:07 PDT
User-Agent:       Mozilla/5.0 (Windows; U; Windows NT 5.1; fr; rv:1.9.0.11) Gecko/2009060215 Firefox/3.0.11 (.NET CLR 3.5.30729)
Build Identifier: Mozilla/5.0 (Windows; U; Windows NT 5.1; fr; rv:1.9.0.11) Gecko/2009060215 Firefox/3.0.11 (.NET CLR 3.5.30729)

With the update from 3.0.10 to 3.0.11, the automatic update program has tried to install without asking anything,
- failed (I was using my limited account),
- retried again and so on.
- I have tried to click on the X of the window without success.
- I have killed Firefox from the process list.
- I have restarted Firefox : same problem...
I have closed my non-admin account and the Internet connection, gone to the admin account to install the already downloaded 3.0.11. No more problem but I have clicked off "auto-check for updates" on all my profiles. This is not too dangerous because I have subscribed to "about:mozilla" that announces updates.
I am not in the case of Bug 318855 or 407875 : I received notifications from "auto-check for updates". 
I think that the offending modifications of automatic update program have been done in 3.0.10 or 3.0.11 : I did not have the problem before.


Reproducible: Always

Steps to Reproduce:
1.Install 3.0.10 with admin right
2.Connect to internet with a limited account with options "auto-check for updates" and in "ask what to do"  "do nothing and wait"
3.Wait for update to 3.0.11 and crashes
Actual Results:  
see details.

Expected Results:  
There are several abnormal things in the automatic update program :
1) It should NEVER have entered an infinite loop : known simple means as a flag in memory can preclude more than 1 unsuccessful try between start and end of Firefox.
2) It should have complied to my "ask what to do" setting. I have checked my options : they are still as said in the paragraph "Additional Information".
3) It should take into account Security minded users that run in non-admin accounts for their normal daily and web surfing activity in particular when an update download occurs but have also an admin account. This does not apply to installations where there is an IT department which makes the updates. 

I think that 1) and 2) should have a very high level e.g. blocking because updates are needed and at least a middle level of expertise is needed to find the solution I have used ; 3) is a big annoyance for many users.

What I wish to have for 3) :
A) "auto-check for updates" ,
B) automatic download of the update,
C) check for admin right, if no, stop with a message asking to go to the admin account ; It may remind me that I have an update to install each session or each day. If yes, it may proceed to install with or without a message.
D) when I log to the admin account, remind me that I have an update to x.y.z to install or at least have a command or a button in Firefox (under admin right) to install the update as soon as I wish (I may have more urgent tasks). Give a message saying that update to x.y.z has succeeded or failed. What to do if I have more than 1 update to install ? Run several time the process each time with the reminder and result messages or automatically loop without reminder ?

I think that Thunderbird may have the same problem. Do I have to duplicate this bug report against it ?

Now I am Mozilla/5.0 (Windows; U; Windows NT 5.1; fr; rv:1.9.0.11) Gecko/2009060215 Firefox/3.0.11 (.NET CLR 3.5.30729)
I am a Security minded personal user : I run in non-admin account for my normal daily and web surfing activity. When I wish to install or update a program, I download it with my limited account, disconnect from the Internet, and install it with my admin account. I am connected to Internet with my admin account only for a short period and when I cannot do otherwise (e.g. Windows update). I know that with this configuration the automatic update function of Firefox and Thunderbird fails. So i have set my non-admin profile to "auto-check for updates" then "ask what to do" I answer "do nothing and wait", download the full new version of Firefox and Thunderbird. When I am sure that the extensions that I absolutely need are compatible, I go to my admin account without being connected to Internet, install Firefox or Thunderbird and I have no more message before the next update. This is inelegant but has worked well up to the update from 3.0.10 to 3.0.11
Comment 1 Jean-Marie COUPRIE 2009-10-14 00:16:53 PDT
Please clarify what I have not specified and has been added : my report included Mozilla/5.0 (Windows; U; Windows NT 5.1; fr; rv:1.9.0.11)
Gecko/2009060215 Firefox/3.0.11 (.NET CLR 3.5.30729)
Comment 2 Wayne Mery (:wsmwk, NI for questions) 2009-10-23 12:53:45 PDT
rs or someone might have more specific advice. But you might try v3.5. or v3.6 now in beta.  3.0 is soon over the hill.
Comment 3 Jean-Marie COUPRIE 2009-11-10 09:51:42 PST
Today Firefox has loaded some update and of course failed to install it  but without infinite loop this time :
I use a limited right account with the advanced option check for update UNCHECKED. I don't understand how it can load an update with this setting !
If this can help I am : Mozilla/5.0 (Windows; U; Windows NT 5.1; fr; rv:1.9.1.3) Gecko/20090824 Firefox/3.5.3 (.NET CLR 3.5.30729).
To clarify my position, I don't ask to correct a particular release of the updates or the update program : they are soon outdated. I wish that you do a general search on bugs in updates : why can they loop or be loaded against the will of the user.
Comment 4 Jean-Marie COUPRIE 2010-01-12 09:58:38 PST
With 3.5.5 the update to 3.5.6 has been downloaded automatically and each time Firefox started, it ask to wait then that the update cannot install (the account with which I surf is limited without administrator right) but it does not retry during the Firefox session : no more infinite loop ! But this download should not have occurred in the options the check for updates is NOT checked.
I have updated to 3.5.6 and the problem has disappeared. The 3.5.7 is now available and I have no problem.
When do you plan to have a correct auto update that works with limited account surf ? It seems easy to download the update then test if the account has administrator right (open source program AutoHotkey has an instruction to do this). If he has not, ask the user to go to his administrator account to do the second part (installation) of the update (without being connected to the net).
Please cross-reference bug 534090 supposed to be fixed by 3.5.7. It seems that now the updates are done automatically and this always...
Comment 5 Robert Strong [:rstrong] (use needinfo to contact me) 2010-01-12 10:44:30 PST
For reference from bug 534090 comment #63 (let's keep the comments in the open bug)

> Sorry to comment so late but I think that there are problems that you have not
> seen in the discussion of this bug. I have just discovered this bug reading
> what is new in 3.5.7.
> 
> 1)I am a Security minded personal user : I run in non-admin account for my
> normal daily and web surfing activity. According the security sites advices, I
> divide by 4 to 5 the probability that malwares install with this. But with a
> non admin account an update cannot be installed and I have an error message at
> the beginning of the Firefox session. See my Bug 500303.
> 
> 2) I have 3 profiles with different add-ons installed (add-ons are installed in
> the profile and not common to all of them). The update program can easily check
> which add-ons are in the active profile and if they are compatible. But how can
> it do the same in the 2 inactive profiles ?
> 
> 3) I think that the automatic update should be cut in 2 parts :
> a) download of the update even with a limited account and test if account has
> administrator rights or right to write in the case of limited user installed
> Firefox. If not, send a message to the user asking to go to administrator
> account without being connected to the net.
> b) installation only if the previous test is OK.
> b)install only
Comment 6 Robert Strong [:rstrong] (use needinfo to contact me) 2010-01-12 13:03:49 PST
(In reply to bug 534090 comment #63)
> Sorry to comment so late but I think that there are problems that you have not
> seen in the discussion of this bug. I have just discovered this bug reading
> what is new in 3.5.7.
note: Bug 534090 has to do with backing out a change that was made to 3.0 that prevented notification under some circumstances and has nothing to do with this bug.

> 1)I am a Security minded personal user : I run in non-admin account for my
> normal daily and web surfing activity. According the security sites advices, I
> divide by 4 to 5 the probability that malwares install with this. But with a
> non admin account an update cannot be installed and I have an error message at
> the beginning of the Firefox session. See my Bug 500303.
What groups are your limited user account a member of? Please attach the install.log from your Firefox installation directory.

> 2) I have 3 profiles with different add-ons installed (add-ons are installed in
> the profile and not common to all of them). The update program can easily check
> which add-ons are in the active profile and if they are compatible. But how can
> it do the same in the 2 inactive profiles ?
It can't. It also can't check profiles for other Windows user accounts. The add-on compatibility check is best effort to cover the typical case of a user having only one profile. Also note that the profile manager UI will likely be removed at some point per bug 214675.

> 3) I think that the automatic update should be cut in 2 parts :
> a) download of the update even with a limited account and test if account has
> administrator rights or right to write in the case of limited user installed
> Firefox. If not, send a message to the user asking to go to administrator
> account without being connected to the net.
> b) installation only if the previous test is OK.
> b)install only
It only downloads if app update thinks you can update which is based on several checks (essentially what you are asking for without the download) and as of Firefox 3.6 it will notify the user that there is an update available. There are known instances where this can fail and they would also fail using the steps you have outlined since the it would use the same checks. Firguring out where the check is failing would be the next step and we already know of one failure though we don't yet have a way to fix it.

btw: Bug 538533 should fix the infinite loop but it doesn't prevent the failure for the partial patch failure (if available) and the complete patch failure before providing the url to get the manual update.
Comment 7 Jean-Marie COUPRIE 2010-01-13 12:21:28 PST
"What groups are your limited user account a member of? Please attach the
install.log from your Firefox installation directory." I have note defined groups so I assume each Windows account is a group by itself. I am perhaps security paranoiac, but nothing prevent a hacker to create a bugzilla account and use my install.log. I'll mail it directly to you.

"Also note that the profile manager UI will likely be removed at some point per bug 214675." I have posted in it why I have defined and need 3 profiles or equivalent functionality.

"Bug 538533 should fix the infinite loop" Good. The last attachment is too much for me except the comments. Can it download the partial update, give me a message once, and install the update when I have restarted FF using my administrator account ? Now I systematically download the full update with my limited account, close FF, then shift to the administrator account and install : not a glorious way but it always work !
Comment 8 Robert Strong [:rstrong] (use needinfo to contact me) 2010-01-13 12:28:46 PST
(In reply to comment #7)
> "What groups are your limited user account a member of? Please attach the
> install.log from your Firefox installation directory." I have note defined
> groups so I assume each Windows account is a group by itself. I am perhaps
> security paranoiac, but nothing prevent a hacker to create a bugzilla account
> and use my install.log. I'll mail it directly to you.
Third party app's will often create additional groups and / or add users to existing groups. "each Windows account is a group by itself" is not possible since accounts and groups are two different things.

The install.log just provides details in regards to how Firefox was installed. For now, just provide the install directory path in a bugzilla comment.

> 
> "Bug 538533 should fix the infinite loop" Good. The last attachment is too much
> for me except the comments. Can it download the partial update, give me a
> message once, and install the update when I have restarted FF using my
> administrator account ?
It can't. There are other bugs to make that process better but none of them will allow one user to download and another to install since that would require passing between security boundaries on the filesystem.
Comment 9 Jean-Marie COUPRIE 2010-01-18 10:58:14 PST
My install.log is 33.5 K . Is there a more clever method than past and glue it here ?
Install Dir: D:\Mozf
  Locale     : fr
  App Version: 3.5.7
  GRE Version: 1.9.1.7
D partition is NTFS, the sub-directory created by administrator account and I have access (at least in read mode) to Install.log with with my limited account that I presently use.

"allow one user to download and another to install since that would require
passing between security boundaries on the filesystem." In XP home that I run, except if a file has been declared as "confidential" by its owner e.g. the creator of it, the administrator has full control on it that means in particular the right to access it in read mode to install it content. I think that this apply also to Vista or 7 and probably to other OS. So access to a file written (or owned) by a limited access account is normally allowed to an administrator without violating security rules/boundaries. As I have previously stated :" Now I systematically download the full update " to a known simple directory reserved for download "with my limited account, close FF, then shift to the administrator account and install : not a glorious way but it always work "
Comment 10 Robert Strong [:rstrong] (use needinfo to contact me) 2010-01-18 15:37:17 PST
That isn't typically the case. The files in the profile can't typically be accessed by an admin account without first taking ownership which is not something we would ever consider doing.
Comment 11 Robert Strong [:rstrong] (use needinfo to contact me) 2010-01-18 15:39:32 PST
What are the permissions set on this non-standard install location? 
D:\Mozf
Comment 12 Robert Strong [:rstrong] (use needinfo to contact me) 2010-01-18 15:48:19 PST
These are failures to updates and not crashes.
Comment 13 Robert Strong [:rstrong] (use needinfo to contact me) 2010-01-18 15:50:07 PST
Can you try installing into the standard location under program files (do not change the permissions on the directory) and then try it?
Comment 14 Jean-Marie COUPRIE 2010-01-19 07:06:53 PST
"What are the permissions" I'll say "default" : I use XP Home, with which it is very difficult to manipulate, access or see the permissions (except to make a file "confidential" and so reserved to the owner) : you have to start in safe mode ! My disk has been partitioned, D:\Mozf directory created by the administrator account that is so the owner, then FF installed in it, all of these without changing permissions. This answer may not be fully satisfactory for you but I don't think that other XP home users do differently...

"non-standard install" : Is partitioned disk a standard or not ? When I bought my first PC 10 years ago with W 98 it has only C: and you needed a commercial program to partition it else you loose the content using fdisk. Partitioning was not standard but highly recommended by my PC club due to the fact that W 98 needed to be reinstalled (after crash) once a year and in this case all the content of C: is lost. My fixed PC is intermediate : to partition there were also free-wares or Linux live CD (qparted). The lap top I bought last summer has "off the shelf" 2 equal partitions C: for the system, D: for my data. With Vista you can shrink C: and create new partition without loosing any data. Now partitioning is standard and Firefox not standard by not supporting it well !
 The D: partition for programs has limited interest because 2/3 of my programs use registry and so need to be reinstalled after format of C: . In the future, when "portable applications" support multiple users, they will be installed in D: instead of normal versions and avoid re-installation of programs after Windows re-installation. The E: partition should be mandatory for user data ; Presently I need to edit profiles.ini to move profiles data out of C: (see knowledge database).

"The files in the profile can't typically be accessed by an admin account". I have no problem to access by my admin account the "profiles.ini" of my limited account, other files are in E:. The profile is not a good candidate as a place to download update file : I have 3 profiles in my limited account and other accounts for my children, how the admin account can determine which has downloaded ? The right to write in "program file" have been drastically limited and I am not sure that a limited account can use it. "Shared documents" are a better candidate : already 2 programs have created their own subdirectories in it, one of them is "iMacro" a Firefox extension. "C:\temp\ seems also to work on my PC.

"Can" I "try installing into the standard location under program files" without un-installing my previous Firefox ? Due to the paragraph above, I don't see the interest. Please advise.

"These are failures to updates and not crashes." An infinite repetitive loop (the origin of this bug) is for me equivalent to a crash. With the improvements in the latter releases it become just a bug with a very annoying delay and error message at each start of Firefox ! Also a security exposure if I remain with an old release with documented bugs and exploit for them.
Comment 15 [not reading bugmail] 2010-01-20 21:24:13 PST
For testing purposes, given your PC setup with multiple XP user profiles and multiple partitioned drives (and drive letters should be ok with XP)...
 We need to determine what the root cause of the problem is to help you help us.
Running from an admin account would all allow it to run from any admin profile in any location off any drive and install to any location.  Chances are your user profile may have limited write permissions, so when you click to upgrade, your user profile maybe doesn't have write permissions to write to the location that admin installed FF into.

So try this... as I don't have XP at home or FF 3.0.x to test a similar configuration.

Check to see if folder x:\Program Files\Mozilla\Firefox exists. 
I believe you have the ability to review user account permissions for the rest of the XP users under the admin account, but not from a user account. 

Note: If you don't already have it installed at the default location, creating another installed copy of firefox in another location will not matter other than shortcuts created by the installer to point to the new folder.  But you can install multiple copies of firefox on the PC and in multiple start menu all programs folders - configured during the installer custom option.

Next: Are you able to manually download the firefox installer from your user profile, save the file to say your storage drive (ie E:\downloads\) from your user limited profile, and then run the installer with your user profile using the default standard installer option, which should just install FF into FF's default folder location and does that work?  If not, you have a case of read/write permissions where the admin is the only user able to update/and write/save to Firefox's update folder Firefox uses to update itself.   

Now if you were able to install from your user profile, to FF default location, all XP users would see it as an option and you should be able to update it from that same profile if all users had write permissions to the FF installation folder.  Otherwise the Admin, like you said, has full read/write permissions to alone update the browser inside any system folder.
 


I personally download firefox 3.5+ for XP all the time at work and I install it not into the default location, but I modify it so its not installed under x:\documents and settings\all users\application data\... for (FF 3.6)

but I install it to a custom folder: 

x:\documents and settings\"insert my user profile name here"\application data\... (FF 3.6)

or try installing into x:\Program Files\Mozilla\Firefox x\ (is this 3.0 default location?)

which works often if you don't have limited write permissions for the user profiles to the drive partitions.

I personally have run into a case of trying to install FF on a system which had been installed by another user to XP's All Users folder (such as from an admin account) but then I tried to update that version, i cannot and I cannot install FF on the machine from my user account.  

If your user permissions are limited for read/write, we'd like to know for sure as it would be helpful as well as knowing if your currently installed copy of FF is in a non standard location where you might have limited read/write permissions.  

This is about all I can think of.  Needing Admin rights to install into Vista/Win7 is definitely a concern to install/update FF with UAC running., so you maybe seeing the older release with similar issues.
Comment 16 Robert Strong [:rstrong] (use needinfo to contact me) 2010-01-20 22:41:09 PST
Ditto what Dale said... we need this information to try to figure out what is going on with your specific system. I've verified on XP that app update works correctly using the standard install location (e.g. the default one set by the installer which is typically c:\program files\mozilla firefox\) as well as in a non-standard install location as long as the non-standard install location has the correct permissions set on the directory (essentially full control for the user that is performing the update). There are several permission settings that can and will break app update.

We have specific people that work on crashes and they wouldn't work on this bug hence why I removed the crash keyword.

Now instead of replying with "default" as the permissions set and writing a long post can you please just look at the permissions? Here is one page that shows how to view them but you will of course need to do this on the Firefox installation directory.
http://www.microsoft.com/windowsxp/using/networking/security/permissions.mspx

If you can install into the standard install location (e.g. c:\program files\mozilla firefox\) and then test if you can update that would also provide useful information.
Comment 17 Jean-Marie COUPRIE 2010-01-21 07:28:55 PST
Answers to Comment #15 and 16
The folder C:\Program Files\Mozilla\Firefox does not exist. 

"I believe you have the ability to review user account permissions for the rest of the XP users under the admin account, but not from a user account. "
I have tried to do this under the admin account, using the link (dated 2006) given in Comment #16 :
http://www.microsoft.com/windowsxp/using/networking/security/permissions.mspx
I have the French version of Windows home (original CD was SP2 OEM, my installation has been updated up to last week) that should have the same functionalities of course with different wordings.  At 4. "Click the Security tab.", instead of the shown screen I have the equivalent of 4. of
http://www.microsoft.com/windowsxp/using/networking/maintain/share.mspx . This problem arise in normal mode, I can access the security tab in SAFE mode : that should have been stated in the Microsoft document ! I have permissions in the FF install directory D:\Mozf\ that are defined for administrators, system and users (as a whole not by names), they are no for modify or write, yes for read and execute, show content (?), read, special permissions (inherit from parents, read and execute). As I have set nothing particular I think that these are the "default" options of Windows.

With my limited account I down-loaded the full installer en/us (to ease further discussions) version of FF in E:\download\ (without s to avoid conflict) created by this account. I tried "standard" but the installer insisted to put it in D:\Mozf\ without other choice, I tried "custom" and pointed it to C:\Program Files\ , I had the message :
"You don't have access to write to the installation directory.
click OK to select a different directory."
then I tried with explorer and the limited account to create C:\Program Files\Mozilla\ , I had the French message equivalent to :
"not possible to create 'new folder' access denied" . I think that I have recently read that write access to C:\Program Files\ has been denied to limited accounts to avoid installation of malwares when surfing.
 What do you wish that I try now ? Install in D:\MozfUS\ created by the limited access account that will be the owner and so probably have right to write ? Install in C:\Program Files\ with the administrator account ? Then try to update with the limited account ?

BTW I don't like the idea to allow automatic updates : it may block (till they are made compatible) the use of extensions that I absolutely need.
Comment 18 Robert Strong [:rstrong] (use needinfo to contact me) 2010-01-21 07:36:44 PST
Uninstall the existing install with the account you used to install the existing install. Install using the administrator account, select custom, verify that it is located under Program Files directory (it should be), complete the install, and verify that the limited user cannot check for updates.
Comment 19 Jean-Marie COUPRIE 2010-01-21 13:03:30 PST
"Verify that the limited user cannot check for updates."
How ?
I hope I'll not have too much problems regaining my profiles !
Comment 20 Robert Strong [:rstrong] (use needinfo to contact me) 2010-01-21 20:25:41 PST
The Check for updates menu item under the Help menu should be disabled.

The uninstaller does not touch profiles unless you explicitly check the checkbox for removing profiles (it also includes text warning that the data will not be recoverable).
Comment 21 Jean-Marie COUPRIE 2010-01-22 01:46:20 PST
Before uninstall of 3.5.7 "The Check for updates menu item under the Help menu " was not disabled on the limited account and proposed 3.6. Is this normal ?
I know that uninstall does not erase profiles (I have uninstalled previously before each major update installation, for minor I just install in place). But does it automatically "reconnect" to old profiles when I change installation directory ?
In case of problems, I'll backup my profiles...
According comment comment 18, I'll uninstall with admin that has done previous install.
Which version does I reinstall ? 3.5.7 ? 3.6 ? A previous one ?
Comment 22 Robert Strong [:rstrong] (use needinfo to contact me) 2010-01-22 01:55:00 PST
(In reply to comment #21)
> Before uninstall of 3.5.7 "The Check for updates menu item under the Help menu
> " was not disabled on the limited account and proposed 3.6. Is this normal ?
Typically Check for updates on 3.5.7 would be disabled for a limited account.

> I know that uninstall does not erase profiles (I have uninstalled previously
> before each major update installation, for minor I just install in place). But
> does it automatically "reconnect" to old profiles when I change installation
> directory ?
Yes

> In case of problems, I'll backup my profiles...
Always a good idea.

> According comment comment 18, I'll uninstall with admin that has done previous
> install.
> Which version does I reinstall ? 3.5.7 ? 3.6 ? A previous one ?
You can install 3.6 if you would like to start using 3.6. With 3.6 Check for updates will be enabled but when an update is found it will just inform you that an update is available with a link to download the new version. You can at that time either download the new version and install it using the privileged account or launch Firefox with the privileged account to use the internal update mechanism.
Comment 23 [not reading bugmail] 2010-01-22 19:09:12 PST
I forget that is seems if you already have FF installed, selection the standard installer option tends to remember where you put it last, so i think i might have said something that did match actual process, not intentional of course but by trying to think standard always equals default, and FF to me is different then other programs, since we can turn standard install into upgrade automatically. 

Rob, is this a correct assumption? 

It just dawned on me that if I forgot how it works as noted by Jean's experience, trying to help support, imagine how many other people do the same, and maybe this is not clear to users in general, probably good enough for a survey and a bug report.
Comment 24 Robert Strong [:rstrong] (use needinfo to contact me) 2010-01-25 13:39:23 PST
(In reply to comment #23)
> I forget that is seems if you already have FF installed, selection the standard
> installer option tends to remember where you put it last, so i think i might
> have said something that did match actual process, not intentional of course
> but by trying to think standard always equals default, and FF to me is
> different then other programs, since we can turn standard install into upgrade
> automatically. 
> 
> Rob, is this a correct assumption? 
Which is why I asked him to uninstall first.

For the standard case when installing a release build we upgrade an existing release build except when there is more than one release build already installed then we default to the standard install location which is dependent upon the user's rights.

> It just dawned on me that if I forgot how it works as noted by Jean's
> experience, trying to help support, imagine how many other people do the same,
> and maybe this is not clear to users in general, probably good enough for a
> survey and a bug report.
This specific case is different than the norm and I asked Jean to install under program files because the behavior he is experiencing isn't what the vast majority of users experience based on testing.
Comment 25 Jean-Marie COUPRIE 2010-02-04 09:09:37 PST
I have been very busy this time : this delayed my answer.
What I have done :
1) without modifying my installation I created with my limited account a repertory Download in my E: partition and downloaded the full installer of 3.5.7 English version in it. I have not checked (I can do it only in SAFE mode) the right to access.
2) I backuped my FF data.
3) done what you requested :
"Uninstall the existing install with the account" (administrator) "you used to install the existing install. Install using the administrator account" (I have put in the execute box the full path name of the download)", select custom, verify that it is located under Program Files directory (it should be)" (Yes, it is) ", complete the install, and verify that the limited user cannot check for updates." check for update is greyed and does nothing.
My Firefox work normally (it has automatically found its profiles) except that it speak English !

This experiment seems to prove 2 things when working with XP home :
a) when FF is installed in Program Files the update works as you hoped but not if it is installed in an other partition. I think that it is a bug.
b) if an installer is loaded by a limited account in a known place, the administrator account can install it. You can, as I suggested, cut the update program in 2 parts : download with limited account then install with administrator account.

What does I test now ?
-check the access rights to E:\download ?
-Try to update to 3.6 from administrator account ?
-Go back to D: partition to check periodically if you have improved the update situation ?
-How to transform it to a French version ?
Comment 26 Robert Strong [:rstrong] (use needinfo to contact me) 2010-02-04 09:41:40 PST
From your comment #17:
> I can access the security tab in SAFE mode : that
> should have been stated in the Microsoft document !
It wasn't stated in the document because you should be able to access the security tab without using safe mode. Safe mode loads a subset of your installed drivers and it is likely that you have installed software that is not loaded when Windows is booted in safe mode that is preventing access to the security tab.

> I have permissions in the
> FF install directory D:\Mozf\ that are defined for administrators, system and
> users (as a whole not by names), they are no for modify or write, yes for read
> and execute, show content (?), read, special permissions (inherit from parents,
> read and execute). As I have set nothing particular I think that these are the
> "default" options of Windows.
Typical settings would have modify and write for administrators. I suspect whatever is breaking Windows from allowing access to the security tab from your admin account is also breaking app update.

If you'd like Firefox update when installed in your d: partition to behave the same as it does under Program Files (e.g. admins can update, regular users can't) set the permissions on the Firefox installation directory to be the same as the permission for the Firefox directory under program files. If you are not able to do so without running safe mode then you will likely need to first fix whatever is causing the problem with setting permissions on your d: partition.
Comment 27 Robert Strong [:rstrong] (use needinfo to contact me) 2010-02-04 10:53:34 PST
Note that my suspicion that a 3rd party driver / app causing a bug where you are not being able to see the security tab is just a suspicion... it could be caused by something else. My statement that you should be able to see the security tab under normal conditions is not a suspicion. Also, my statement about the administrator account typically should have write / modify (it should have Full Control which includes write and modify) is also not a suspicion. The permissions on this drive do not appear to be normal (e.g. "default").

Finding / fixing the cause of why you are unable to see the security tab should be your first step... a Windows forum or Microsoft PSS should be able to help you with this. After that is fixed, setting the permissions on the install directory to be the same as the one under Program Files will give you the same update behavior as when it is installed under Program Files. If you manually set the permissions on the installation directory on your d: partition then be sure to select replace all child object permissions etc. under advanced.
Comment 28 Jean-Marie COUPRIE 2010-02-11 05:33:23 PST
We are misunderstanding one another ! I have gigen in comment 15 only the permissions for users, it seemed for me that it was obvious that administrator has the complete list of permissions. I have checked today : users have execute , read data and read attributes rights in both D:\MozF and C:\program files and administrator the full list of permission. So "you will likely need to first fix whatever is causing the problem with setting permissions on your d: partition." does not apply.

The safe mode is an other problem : most of the info I have found,say that you have to be in safe mode to see security tab of XP home or to use third party software ; there is also a work around using a part of SCESP4I.EXE ( 2 xxx.reg : on/off) to fool the system that thinks it is in safe mode but this is said to be dangerous and recommended to exit of this situation to normal mode asap.
 This is a part of what I have found :
http://www.tweakhound.com/xp/xpperm/xpPerm2.htm
"Start in SAFE MODE. Right click on the folder or file. Choose PROPERTIES. You get the following screen:"

http://support.microsoft.com/kb/308421
How to take ownership of a file or a folder in Windows XP
Article ID: 308421 - Last Review: November 6, 2008 - Revision: 3.1
"Start Windows XP Home Edition in safe mode...."

http://www.microsoft.com/communities/newsgroups/en-us/default.aspx?dg=microsoft.public.windowsxp.security_admin&tid=2a1f6c9b-0642-4939-933a-d9a83b7975a5&cat=en_US_649a30ca-5c6a-454c-995f-663a9bdbd12f&lang=en&cr=US&sloc=&p=1
"That's because what you are reading is for XP Pro, in order to have that tab
in Home Edition you need to boot to safe mode. "
http://support.microsoft.com/kb/938720
"Note In Windows XP Home Edition, the Security tab appears only when the computer is running in safe mode. "

http://www.microsoft.com/windowsxp/using/networking/security/permissions.mspx
seems to be the only one not asking for safe mode !

Search on "Why-is-the-Security-tab-missing-from-my-file-and-folder-properties" you will find the problem exist for Vista or Windows 7  in their home versions...

I fear that my XP Home is standard but that yours is patched or use third party software.
Comment 29 Wayne Mery (:wsmwk, NI for questions) 2011-02-17 05:17:15 PST
Jean-Marie do you continue to see this problem when using newer version of firefox?
Comment 30 Jean-Marie COUPRIE 2011-03-03 06:54:37 PST
In my option automatic check for updates is unchecked so I have no more problem with updates !
But this does not prove that the bug has disappeared only that it is hidden by my "final solution".
I learn through "about:mozilla" and a French site send me a mail when a new release is available, I download the complete installer (< 10 MO.) with my limited account and install it with my admin account.
I have put FF back in D:\ .

Do you wish that I check on automatic updates to see if the problem has truly disappeared ?
Comment 31 Jean-Marie COUPRIE 2011-03-31 05:23:43 PDT
New problem :

I use Mozilla/5.0 (Windows; U; Windows NT 5.1; fr; rv:1.9.2.15) Gecko/20110303 Firefox/3.6.15 ( .NET CLR 3.5.30729; .NET4.0C) and now 4.0 is available (but I wish to wait for the next release before updating : I have been burnt by new releases that make FF or TB incredibly slow). In my options automatic check for updates is unchecked so I should never receive automatic updates : As I use a limited account to surf, automatic updates cannot install.

Never the less this is the second day that, at start of FF, I receive the message in French "La mise à jour n'a pas pu être installée. Assurez-vous qu'aucune autre copie de Firefox n'est en cours d'exécution sur votre ordinateur, et redémarrez Firefox pour réessayer." or in English "Update could not be installed. Check that you have not an other copy of FF running and restart FF to try again" or something like.

If you don't wish to implement (as security requires) a way to download the update with a limited account then install it with administrator rights being unconnected from the net, at least implement in tools a command to force download and install update at highest priority : I'll need to connect to the net with administrator right only for a minute or less : this limit the risk...
Comment 32 Jean-Marie COUPRIE 2011-04-17 09:38:58 PDT
It is boring to receive the same error message each time I start Firefox !
Please do something...
Comment 33 Pablo Aguilar 2012-02-12 04:02:44 PST
It happens to me since roughly one year now, i'm using Nightly updates, 90 % of them fails and forces me to upload a installer and manually update...

I'm using Windows 7 x64 and Nightly (13.0a1 (2012-02-10))...

My user is and Administrator with all the rights!!!
Comment 34 uvoxjoker 2012-05-31 01:53:37 PDT
Try to unpin Firefox from the work bar of Win7.
Open Firefox from the Start Menu and see if the automatic update can work.
Comment 35 Gabriela [:gaby2300] 2012-07-13 15:26:53 PDT
Works fine for me using Windows 7 and Build identifier: Mozilla/5.0 (Windows NT 6.1; rv:16.0) Gecko/16.0 Firefox/16.0 20120713.
Comment 36 kitchin 2012-07-24 10:12:49 PDT
See also: Bug 768278
Comment 37 kitchin 2012-08-18 03:55:34 PDT
This bug is not WFM. I left another report at Bug 768278.

Note You need to log in before you can comment on or make changes to this bug.